/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB� Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB� Code Configurator - v2.25.2
        Device            :  PIC16F1614
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set channel_Y2 aliases
#define channel_Y2_TRIS               TRISA2
#define channel_Y2_LAT                LATA2
#define channel_Y2_PORT               RA2
#define channel_Y2_ANS                ANSA2
#define channel_Y2_SetHigh()    do { LATA2 = 1; } while(0)
#define channel_Y2_SetLow()   do { LATA2 = 0; } while(0)
#define channel_Y2_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define channel_Y2_GetValue()         RA2
#define channel_Y2_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define channel_Y2_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define channel_Y2_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define channel_Y2_SetDigitalMode()   do { ANSA2 = 0; } while(0)
// get/set SCK aliases
#define SCK_TRIS               TRISA4
#define SCK_LAT                LATA4
#define SCK_PORT               RA4
#define SCK_WPU                WPUA4
#define SCK_ANS                ANSA4
#define SCK_SetHigh()    do { LATA4 = 1; } while(0)
#define SCK_SetLow()   do { LATA4 = 0; } while(0)
#define SCK_Toggle()   do { LATA4 = ~LATA4; } while(0)
#define SCK_GetValue()         RA4
#define SCK_SetDigitalInput()    do { TRISA4 = 1; } while(0)
#define SCK_SetDigitalOutput()   do { TRISA4 = 0; } while(0)

#define SCK_SetPullup()    do { WPUA4 = 1; } while(0)
#define SCK_ResetPullup()   do { WPUA4 = 0; } while(0)
#define SCK_SetAnalogMode()   do { ANSA4 = 1; } while(0)
#define SCK_SetDigitalMode()   do { ANSA4 = 0; } while(0)
// get/set channel_X2 aliases
#define channel_X2_TRIS               TRISC0
#define channel_X2_LAT                LATC0
#define channel_X2_PORT               RC0
#define channel_X2_ANS                ANSC0
#define channel_X2_SetHigh()    do { LATC0 = 1; } while(0)
#define channel_X2_SetLow()   do { LATC0 = 0; } while(0)
#define channel_X2_Toggle()   do { LATC0 = ~LATC0; } while(0)
#define channel_X2_GetValue()         RC0
#define channel_X2_SetDigitalInput()    do { TRISC0 = 1; } while(0)
#define channel_X2_SetDigitalOutput()   do { TRISC0 = 0; } while(0)

#define channel_X2_SetAnalogMode()   do { ANSC0 = 1; } while(0)
#define channel_X2_SetDigitalMode()   do { ANSC0 = 0; } while(0)
// get/set channel_Y1 aliases
#define channel_Y1_TRIS               TRISC1
#define channel_Y1_LAT                LATC1
#define channel_Y1_PORT               RC1
#define channel_Y1_ANS                ANSC1
#define channel_Y1_SetHigh()    do { LATC1 = 1; } while(0)
#define channel_Y1_SetLow()   do { LATC1 = 0; } while(0)
#define channel_Y1_Toggle()   do { LATC1 = ~LATC1; } while(0)
#define channel_Y1_GetValue()         RC1
#define channel_Y1_SetDigitalInput()    do { TRISC1 = 1; } while(0)
#define channel_Y1_SetDigitalOutput()   do { TRISC1 = 0; } while(0)

#define channel_Y1_SetAnalogMode()   do { ANSC1 = 1; } while(0)
#define channel_Y1_SetDigitalMode()   do { ANSC1 = 0; } while(0)
// get/set channel_X1 aliases
#define channel_X1_TRIS               TRISC2
#define channel_X1_LAT                LATC2
#define channel_X1_PORT               RC2
#define channel_X1_ANS                ANSC2
#define channel_X1_SetHigh()    do { LATC2 = 1; } while(0)
#define channel_X1_SetLow()   do { LATC2 = 0; } while(0)
#define channel_X1_Toggle()   do { LATC2 = ~LATC2; } while(0)
#define channel_X1_GetValue()         RC2
#define channel_X1_SetDigitalInput()    do { TRISC2 = 1; } while(0)
#define channel_X1_SetDigitalOutput()   do { TRISC2 = 0; } while(0)

#define channel_X1_SetAnalogMode()   do { ANSC2 = 1; } while(0)
#define channel_X1_SetDigitalMode()   do { ANSC2 = 0; } while(0)
// get/set DAC_CS aliases
#define DAC_CS_TRIS               TRISC3
#define DAC_CS_LAT                LATC3
#define DAC_CS_PORT               RC3
#define DAC_CS_ANS                ANSC3
#define DAC_CS_SetHigh()    do { LATC3 = 1; } while(0)
#define DAC_CS_SetLow()   do { LATC3 = 0; } while(0)
#define DAC_CS_Toggle()   do { LATC3 = ~LATC3; } while(0)
#define DAC_CS_GetValue()         RC3
#define DAC_CS_SetDigitalInput()    do { TRISC3 = 1; } while(0)
#define DAC_CS_SetDigitalOutput()   do { TRISC3 = 0; } while(0)

#define DAC_CS_SetAnalogMode()   do { ANSC3 = 1; } while(0)
#define DAC_CS_SetDigitalMode()   do { ANSC3 = 0; } while(0)
// get/set SDO aliases
#define SDO_TRIS               TRISC4
#define SDO_LAT                LATC4
#define SDO_PORT               RC4
#define SDO_WPU                WPUC4
#define SDO_SetHigh()    do { LATC4 = 1; } while(0)
#define SDO_SetLow()   do { LATC4 = 0; } while(0)
#define SDO_Toggle()   do { LATC4 = ~LATC4; } while(0)
#define SDO_GetValue()         RC4
#define SDO_SetDigitalInput()    do { TRISC4 = 1; } while(0)
#define SDO_SetDigitalOutput()   do { TRISC4 = 0; } while(0)

#define SDO_SetPullup()    do { WPUC4 = 1; } while(0)
#define SDO_ResetPullup()   do { WPUC4 = 0; } while(0)
// get/set SDI aliases
#define SDI_TRIS               TRISC5
#define SDI_LAT                LATC5
#define SDI_PORT               RC5
#define SDI_WPU                WPUC5
#define SDI_SetHigh()    do { LATC5 = 1; } while(0)
#define SDI_SetLow()   do { LATC5 = 0; } while(0)
#define SDI_Toggle()   do { LATC5 = ~LATC5; } while(0)
#define SDI_GetValue()         RC5
#define SDI_SetDigitalInput()    do { TRISC5 = 1; } while(0)
#define SDI_SetDigitalOutput()   do { TRISC5 = 0; } while(0)

#define SDI_SetPullup()    do { WPUC5 = 1; } while(0)
#define SDI_ResetPullup()   do { WPUC5 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize(void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
 */